const NodeSSH = require('node-ssh')

const ssh = new NodeSSH()
const config = require('../config').ssh

/**
 * ssh 上传
 */
exports.uploadFile = async (localFile, remoteFile) => {
  try {
    await ssh.connect(config)
    await ssh.putFile(localFile, remoteFile)
    ssh.dispose()
  } catch (err) {
    throw new Error(err.message)
  }
}


/**
 * ssh 下载
 */
exports.downloadFile = async (localFile, remoteFile) => {
  try {
    await ssh.connect(config)
    await ssh.getFile(localFile, remoteFile)
    ssh.dispose()
  } catch (err) {
    throw new Error(err.message)
  }
}
