const shell = require('shelljs')
const path = require('path')
const fs = require('fs')
const rm = require('rimraf').sync

/**
 * 压缩
 */
exports.compress = (srcPath, destPath) => {
  if(!fs.statSync(srcPath).isDirectory()) {
    throw new Error('src path must be directory!')
  }

  // tar compress
  // const srcRoot = srcPath.substring(0, srcPath.lastIndexOf('/'))
  const fileName = path.basename(srcPath)
  const tarName = `${fileName}.tar.gz`
  const r = shell.exec(`cd ${srcPath} && tar -zcvf ${tarName} --exclude=node_modules --exclude=.git --exclude=.gitignore --exclude=package-lock.json --exclude=.idea ./`)
  if(r.code !== 0) {
    throw new Error('tar compress failed!')
  }

  // mkdir
  if (!fs.existsSync(destPath)) {
    shell.mkdir('-p', destPath)
  }

  // cp
  shell.mv(`${srcPath}/${tarName}`, destPath);

  return tarName
}


/**
 * 解压缩
 */
exports.uncompress = (tarFile) => {
  if (!fs.existsSync(tarFile)) {
    throw new Error('tar file not found!')
  }

  // if (!fs.existsSync(destPath)) {
  //   shell.mkdir('-p', destPath)
  // }

  const tarName = path.basename(tarFile)
  const tarPath = tarFile.substring(0, tarFile.indexOf(tarName))

  // tar uncompress
  const r = shell.exec(`cd ${tarPath} && tar -zxvf ${tarName}`)
  if(r.code !== 0) {
    throw new Error('tar uncompress failed!')
  }
}
